//
//  ReadMemoryViewController.swift
//  AsReaderGUN
//
//  Created by mac on 2018/7/6.
//  Copyright © 2018年 asterisk. All rights reserved.
//

import UIKit

final class ReadMemoryViewController: UIViewController {
    @IBOutlet private weak var selectionTagLabel: UILabel!
    @IBOutlet private weak var messageLabel: UILabel!
    @IBOutlet private weak var address1Label: UILabel!
    @IBOutlet private weak var address2Label: UILabel!
    @IBOutlet private weak var address3Label: UILabel!
    @IBOutlet private weak var address4Label: UILabel!
    @IBOutlet private weak var address5Label: UILabel!
    @IBOutlet private weak var address6Label: UILabel!
    @IBOutlet private weak var address7Label: UILabel!
    @IBOutlet private weak var address8Label: UILabel!
    @IBOutlet private weak var value1Label: UILabel!
    @IBOutlet private weak var value2Label: UILabel!
    @IBOutlet private weak var value3Label: UILabel!
    @IBOutlet private weak var value4Label: UILabel!
    @IBOutlet private weak var value5Label: UILabel!
    @IBOutlet private weak var value6Label: UILabel!
    @IBOutlet private weak var value7Label: UILabel!
    @IBOutlet private weak var value8Label: UILabel!
    @IBOutlet private weak var bankTextField: UITextField!
    @IBOutlet private weak var offsetTextField: UITextField!
    @IBOutlet private weak var lengthTextField: UITextField!
    @IBOutlet private weak var passwordTextField: UITextField!
    @IBOutlet private weak var powerGainTextField: UITextField!
    @IBOutlet private weak var operationTimeTextField: UITextField!
    @IBOutlet private weak var readBtn: UIButton!
    @IBOutlet private weak var blockEraseBtn: UIButton!
    @IBOutlet private weak var clearBtn: UIButton!
    @IBOutlet private weak var maskBtn: UIButton!
    @IBOutlet private weak var pickerView: UIPickerView!
    @IBOutlet private weak var bankPickerTopView: UIView!
    @IBOutlet private weak var offsetPickerTopView: UIView!
    @IBOutlet private weak var lengthPickerTopView: UIView!
    @IBOutlet private weak var powerGainPickerTopView: UIView!
    @IBOutlet private weak var rssiLabel: UILabel!
    @IBOutlet private weak var phaseLabel: UILabel!
    @IBOutlet private weak var reportRssiSwitch: UISwitch!
    @IBOutlet private var reportRssiCollection: [UILabel]!
    private enum PickerViewTag: Int {
        case pickerViewBank = 0
        case pickerViewOffset = 1
        case pickerViewLength = 2
        case pickerViewPowerGain = 3
    }
    private weak var appDelegate: AppDelegate?
    private var currentAlertController: UIAlertController?
    private var isActionResult = false
    private var maskType: MaskType?
    private var systemSetting: SystemSetting?
    var maskValue: String? = ""
    private var offsetValue: Int = 0
    private var lengthValue: Int = 0
    private var powerGainPickerData: [String] = []
    private lazy var bankPickerData: [String] = {
        return dataBank
    }()
    private lazy var offsetPickerData: [String] = {
        var tmpArray: [String] = []
        for offset in wordData {
            tmpArray.append("\(offset) WORD")
        }
        return tmpArray
    }()
    private lazy var lengthPickerData: [String] = {
        var tmpArray: [String] = []
        for offset in wordData {
            tmpArray.append("\(offset) WORD")
        }
        return tmpArray
    }()
    private lazy var bitData: [String] = {
        return dataBit
    }()
    private lazy var wordData: [String] = {
        return dataWord
    }()
    override func viewDidLoad() {
        super.viewDidLoad()
        systemSetting = SystemSetting.shared()
    }
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        
        NotificationCenter.default.addObserver(self,
                                               selector: #selector(asReaderGUNDisconnected),
                                               name: NSNotification.Name(rawValue: asreaderGUNDisconnected),
                                               object: nil)
        appDelegate?.mReader?.setDelegate(self)
    }
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
        appDelegate = UIApplication.shared.delegate  as? AppDelegate
        appDelegate?.mReader?.setDelegate(self)
        if appDelegate?.mReader == nil {
            return
        }
        initPowerGainPickerData()
        if let powerGain =  appDelegate?.mReader?.powerGain {
            let nPower = powerGain
            setPowerGain((Int(nPower / 10)))
        }
        appDelegate?.mReader?.continuousMode = false
        maskType = (appDelegate?.mReader?.maskTypeValue).map { MaskType(rawValue: MaskType.RawValue($0)) }
      
        isActionResult = false
        let operationTime = appDelegate?.mReader?.operationTime ?? 0
        setOperationTime("\(operationTime)")
        setBank(1)
        setOffset(2)
        setLength(2)
        if let isReportRSSI = appDelegate?.mReader?.rssiMode {
            setReportRssiModeEnabled(isReportRSSI)
        }
        pickerView.reloadAllComponents()
        
        guard let nowMaskValue = maskValue else {
            return
        }
        guard nowMaskValue.isEmpty else {
            appDelegate?.initMask(nowMaskValue, maskType: MaskType_Selection)
            selectionTagLabel.text = maskValue
            maskBtn.isEnabled = false
            return
        }
    }
    override func viewWillDisappear(_ animated: Bool) {
        super.viewWillDisappear(animated)
        NotificationCenter.default.removeObserver(self,
                                                  name: NSNotification.Name(asreaderGUNDisconnected),
                                                  object: nil)
        guard let nowMaskValue = maskValue else {
            return
        }
        guard nowMaskValue.isEmpty else {
            appDelegate?.exitMask()
            return
        }
    }
    // MARK: - Storyboard Segue
    @IBAction func prepare(forUnwind segue: UIStoryboardSegue) {
    }
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }
    @IBAction func bankBtnTapped(_ sender: UIButton) {
        pickerView.tag = PickerViewTag.pickerViewBank.rawValue
        pickerView.reloadAllComponents()
        pickerView.isHidden = false
        bankPickerTopView.isHidden = false
        if let text = bankTextField.text {
            if !text.isEmpty {
                if let row = bankPickerData.index(of: text) {
                    pickerView.selectRow(row, inComponent: 0, animated: false)
                    return
                }
            }
        }
        pickerView.selectRow(0, inComponent: 0, animated: false)
    }
    @IBAction func offsetBtnTapped(_ sender: UIButton) {
        pickerView.tag = PickerViewTag.pickerViewOffset.rawValue
        pickerView.reloadAllComponents()
        pickerView.isHidden = false
        offsetPickerTopView.isHidden = false
        if let text = offsetTextField.text {
            if !text.isEmpty {
                if let row = offsetPickerData.index(of: text) {
                    pickerView.selectRow(row, inComponent: 0, animated: false)
                    return
                }
            }
        }
        pickerView.selectRow(0, inComponent: 0, animated: false)
    }
    @IBAction func lengthBtnTapped(_ sender: UIButton) {
        pickerView.tag = PickerViewTag.pickerViewLength.rawValue
        pickerView.reloadAllComponents()
        pickerView.isHidden = false
        lengthPickerTopView.isHidden = false
        if let text = lengthTextField.text {
            if !text.isEmpty {
                if let row = lengthPickerData.index(of: text) {
                    pickerView.selectRow(row, inComponent: 0, animated: false)
                    return
                }
            }
        }
        pickerView.selectRow(0, inComponent: 0, animated: false)
    }
    @IBAction func passwordBtnTapped(_ sender: UIButton) {
        let alertController = UIAlertController(title: "Password:", message: "Please enter password.", preferredStyle: .alert)
        alertController.addTextField { (textField) in
            textField.keyboardType = .alphabet
            textField.delegate = self
        }
        let cancelAction = UIAlertAction(title: cancel, style: .cancel, handler: nil)
        let okAction = UIAlertAction(title: ok, style: .default, handler: { _ in
            let text: String = alertController.textFields?.first?.text ?? ""
            self.setPassword(text)
        })
        alertController.addAction(cancelAction)
        alertController.addAction(okAction)
        present(alertController, animated: true, completion: nil)
    }
    @IBAction func powerGainBtnTapped(_ sender: UIButton) {
        pickerView.tag = PickerViewTag.pickerViewPowerGain.rawValue
        pickerView.reloadAllComponents()
        pickerView.isHidden = false
        powerGainPickerTopView.isHidden = false
        if let text = powerGainTextField.text {
            if !text.isEmpty {
                if let row = powerGainPickerData.index(of: text) {
                    pickerView.selectRow(row, inComponent: 0, animated: false)
                    return
                }
            }
        }
        pickerView.selectRow(0, inComponent: 0, animated: false)
    }
    @IBAction func operationTimeBtnTapped(_ sender: UIButton) {
        let alertController = UIAlertController(title: "Operation Time:", message: "Please enter operation time.\n(ex: 30 ms)", preferredStyle: .alert)
        alertController.addTextField { (textField) in
            textField.keyboardType = .numberPad
            textField.delegate = self
        }
        let cancelAction = UIAlertAction(title: cancel, style: .cancel, handler: nil)
        let okAction = UIAlertAction(title: ok, style: .default, handler: { _ in
            var value = alertController.textFields?.first?.text
            guard let text = value else {
                return
            }
            if text.isEmpty {
                value = "0"
            }
            if let aValue = value {
                self.setOperationTime(aValue)
                self.appDelegate?.mReader?.operationTime = Int32(aValue) ?? 0
                self.systemSetting?.setOperationTime(Int(aValue) ?? 0)
            }
        })
        alertController.addAction(cancelAction)
        alertController.addAction(okAction)
        present(alertController, animated: true, completion: nil)
    }
    @IBAction func reportRssiSwitchTapped(_ sender: UISwitch) {
        appDelegate?.mReader?.rssiMode = reportRssiSwitch.isOn
        systemSetting?.setRssiMode(reportRssiSwitch.isOn)
        setReportRssiModeEnabled(reportRssiSwitch.isOn)
    }
    @IBAction func readBtnTapped(_ sender: UIButton) {
        DispatchQueue.main.asyncAfter(deadline: .now() + 0.1) {
            self.readAction()
        }
    }
    @IBAction func blockEraseBtnTapped(_ sender: UIButton) {
        isActionResult = false
        messageLabel.text = "Erasing tag memory.\nPlease wait…"
        if let operationTime = operationTimeTextField.text {
            appDelegate?.mReader?.operationTime = Int32(operationTime) ?? 0
            systemSetting?.setOperationTime(Int(operationTime) ?? 0)
        }
        if let text = bankTextField.text {
            if let row = bankPickerData.index(of: text) {
                let bank: MemoryBank = MemoryBank(rawValue: MemoryBank.RawValue(row))
                appDelegate?.mReader?.blockErase(bank, offset: Int32(offsetValue), length: Int32(lengthValue))
            }
        }
        clearBtnTapped(sender)
    }
    @IBAction func clearBtnTapped(_ sender: UIButton) {
        selectionTagLabel.text = "Result"
        messageLabel.text = msgTagWait
        address1Label.text = "0 WORD"
        address2Label.text = "1 WORD"
        address3Label.text = "2 WORD"
        address4Label.text = "3 WORD"
        address5Label.text = "4 WORD"
        address6Label.text = "5 WORD"
        address7Label.text = "6 WORD"
        address8Label.text = "7 WORD"
        value1Label.text = "0000"
        value2Label.text = "0000"
        value3Label.text = "0000"
        value4Label.text = "0000"
        value5Label.text = "0000"
        value6Label.text = "0000"
        value7Label.text = "0000"
        value8Label.text = "0000"
        rssiLabel.text = "0.0 dB"
        phaseLabel.text = "0.0˚"
    }
    @IBAction func maskBtnTapped(_ sender: UIButton) {
        if maskType == MaskType_Selection {
            performSegue(withIdentifier: "SelectionMask", sender: self)
        } else {
            currentAlertController = UIAlertController(title: "",
                                                       message: "Please choosing the Selection Mask type in the RFID Option menu.",
                                                       preferredStyle: .alert)
            let okAction = UIAlertAction(title: ok, style: .default, handler: nil)
            currentAlertController?.addAction(okAction)
            guard let aleart = currentAlertController else {
                return
            }
            present(aleart, animated: true, completion: nil)
            return
        }
    }
    @IBAction func pickerCloseBtnTapped(_ sender: UIButton) {
        hidePickerView()
    }
    @IBAction func bankPickerOkBtnTapped(_ sender: UIButton) {
        let idx: Int = pickerView.selectedRow(inComponent: 0)
        setBank(idx)
        hidePickerView()
    }
    @IBAction func offsetPickerOkBtnTapped(_ sender: UIButton) {
        let idx: Int = pickerView.selectedRow(inComponent: 0)
        setOffset(idx)
        hidePickerView()
    }
    @IBAction func lengthPickerOkBtnTapped(_ sender: UIButton) {
        let idx: Int = pickerView.selectedRow(inComponent: 0)
        setLength(idx)
        hidePickerView()
    }
    @IBAction func powerGainPickerOkBtnTapped(_ sender: UIButton) {
        var idx: Int32 = Int32(pickerView.selectedRow(inComponent: 0))
        if let min = appDelegate?.mReader?.powerGainRange().min {
            idx += (min / 10)
        }
        setPowerGain(Int(idx))
        appDelegate?.mReader?.powerGain = idx * 10
        systemSetting?.setPowerGain(Int(idx * 10))
        hidePickerView()
    }
}
// MARK: - UIPickerViewDataSource, UIPickerViewDelegate
extension ReadMemoryViewController: UIPickerViewDataSource, UIPickerViewDelegate {
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 1
    }
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        if let pickerViewTag = PickerViewTag(rawValue: pickerView.tag) {
            if pickerViewTag == .pickerViewBank {
                return bankPickerData.count
            } else if pickerViewTag == .pickerViewOffset {
                return bitData.count
            } else if pickerViewTag == .pickerViewLength {
                return lengthPickerData.count
            } else if pickerViewTag == .pickerViewPowerGain {
                return powerGainPickerData.count
            }
        }
        return 0
    }
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        if let pickerViewTag = PickerViewTag(rawValue: pickerView.tag) {
            if pickerViewTag == .pickerViewBank {
                return bankPickerData[row]
            } else if pickerViewTag == .pickerViewOffset {
                return offsetPickerData[row]
            } else if pickerViewTag == .pickerViewLength {
                return lengthPickerData[row]
            } else if pickerViewTag == .pickerViewPowerGain {
                return powerGainPickerData[row]
            }
        }
        return "None"
    }
}
// MARK: - AsReaderDelegate
extension ReadMemoryViewController: AsReaderDelegate {
    func on(asReaderTriggerKeyEvent status: Bool) -> Bool {
        if status {
            readAction()
        }
        return false
    }
    func on(asReaderLeftModeKeyEvent status: Bool) -> Bool {
        guard let rfidModule = appDelegate?.mReader?.isRFIDModule(),
              let barcodeModule = appDelegate?.mReader?.isBarcodeModule() else {
            return false
        }
        return rfidModule && barcodeModule
    }
    func on(asReaderRightModeKeyEvent status: Bool) -> Bool {
        guard let rfidModule = appDelegate?.mReader?.isRFIDModule(),
              let barcodeModule = appDelegate?.mReader?.isBarcodeModule() else {
            return false
        }
        return rfidModule && barcodeModule
    }
    func updateDeviceState(_ error: ResultCode) {
        if error != ResultNoError {
            currentAlertController?.dismiss(animated: true, completion: nil)
            currentAlertController = UIAlertController(title: "Error",
                                                       message: "Failed to get response. Try again.",
                                                       preferredStyle: .alert)
            let okAction = UIAlertAction(title: ok, style: .default, handler: { _ in
                self.navigationController?.popViewController(animated: true)
            })
            currentAlertController?.addAction(okAction)
            guard let aleart = currentAlertController else {
                return
            }
            present(aleart, animated: true, completion: nil)
            return
        }
    }
    func readTag(_ tag: String?, rssi: Float, phase: Float) {
        if let aTag = tag {
            print("RMV - Read Tag: \(aTag)")
        }
    }
    func changedActionState(_ action: CommandType, resultCode: Int) {
        if action == CommandStop {
            currentAlertController?.dismiss(animated: true, completion: nil)
            if !isActionResult {
                messageLabel.text = msgTagWait
            }
        }
    }
    func accessResult(_ error: ResultCode, actionState action: CommandType, epc: String?, data: String?, rssi: Float, phase: Float, frequency: Float) {
        isActionResult = true
        if error != ResultNoError {
            currentAlertController?.dismiss(animated: true, completion: nil)
            messageLabel.text = AsResultCode.msg(error)
            currentAlertController = UIAlertController(title: "Error",
                                                       message: AsResultCode.msg(error),
                                                       preferredStyle: .alert)
            let okAction = UIAlertAction(title: ok, style: .default, handler: nil)
            currentAlertController?.addAction(okAction)
            guard let aleart = currentAlertController else {
                return
            }
            present(aleart, animated: true, completion: nil)
            return
        }
        messageLabel.text = "Success"
        selectionTagLabel.text = epc
        address1Label.text = "\(Int(offsetValue)) WORD"
        address2Label.text = "\(Int(offsetValue + 1)) WORD"
        address3Label.text = "\(Int(offsetValue + 2)) WORD"
        address4Label.text = "\(Int(offsetValue + 3)) WORD"
        address5Label.text = "\(Int(offsetValue + 4)) WORD"
        address6Label.text = "\(Int(offsetValue + 5)) WORD"
        address7Label.text = "\(Int(offsetValue + 6)) WORD"
        address8Label.text = "\(Int(offsetValue + 7)) WORD"
        if var bitArr = data?.components(separatedBy: ",") {
            let bitArrCount = bitArr.count
            if bitArrCount >= 1 {
                value1Label.text = bitArr[0]
            } else {
                value1Label.text = "0000"
            }
            if bitArrCount >= 2 {
                value2Label.text = bitArr[1]
            } else {
                value2Label.text = "0000"
            }
            if bitArrCount >= 3 {
                value3Label.text = bitArr[2]
            } else {
                value3Label.text = "0000"
            }
            if bitArrCount >= 4 {
                value4Label.text = bitArr[3]
            } else {
                value4Label.text = "0000"
            }
            if bitArrCount >= 5 {
                value5Label.text = bitArr[4]
            } else {
                value5Label.text = "0000"
            }
            if bitArrCount >= 6 {
                value6Label.text = bitArr[5]
            } else {
                value6Label.text = "0000"
            }
            if bitArrCount >= 7 {
                value7Label.text = bitArr[6]
            } else {
                value7Label.text = "0000"
            }
            if bitArrCount >= 8 {
                value8Label.text = bitArr[7]
            } else {
                value8Label.text = "0000"
            }
        }
        if !reportRssiSwitch.isOn {
            setReportRssiModeDefault()
        } else {
            rssiLabel.text = String(format: "%.1f dB", rssi)
            phaseLabel.text = String(format: "%.1f˚", phase)
        }
        currentAlertController?.dismiss(animated: true, completion: nil)
    }
}
// MARK: - UITextFieldDelegate
extension ReadMemoryViewController: UITextFieldDelegate {
    func textField(_ textField: UITextField, shouldChangeCharactersIn range: NSRange, replacementString string: String) -> Bool {
        let text = textField.text ?? ""
        let length = text.count + string.count - range.length
        if length > maxPasswordLength {
            return false
        }
        if string.isEmpty {
            return true
        }
        if "0123456789ABCDEFabcdef" .contains(string) {
            let newString = (textField.text as NSString?)?.replacingCharacters(in: range, with: string)
            textField.text = newString?.uppercased()
        }
        return false
    }
}
// MARK: - Custom
extension ReadMemoryViewController {
    private func initPowerGainPickerData() {
        var tmpArray: [String] = []
        if let min = appDelegate?.mReader?.powerGainRange().min,
           let max = appDelegate?.mReader?.powerGainRange().max {
            var index = min
            while index <= max {
                tmpArray.append(String(format: "%i.0 dB", index / 10))
                index += 10
            }
        }
        powerGainPickerData = tmpArray
    }
    private func hidePickerView() {
        bankPickerTopView.isHidden = true
        offsetPickerTopView.isHidden = true
        lengthPickerTopView.isHidden = true
        powerGainPickerTopView.isHidden = true
        pickerView.isHidden = true
    }
    private func readAction() {
        isActionResult = false
        messageLabel.text = "Reading tag memory.\nPlease wait…"
        if let operationTime = operationTimeTextField.text {
            appDelegate?.mReader?.operationTime = Int32(operationTime) ?? 0
            systemSetting?.setOperationTime(Int(operationTime) ?? 0)
        }
        if let bankText = bankTextField.text {
            if let row = bankPickerData.index(of: bankText) {
                 let bank: MemoryBank = MemoryBank(rawValue: MemoryBank.RawValue(row))
                appDelegate?.mReader?.readMemory(bank, offset: Int32(offsetValue), length: Int32(lengthValue))
            }
        }
        let password = passwordTextField.text
        appDelegate?.mReader?.accessPassword = password
        currentAlertController?.dismiss(animated: true, completion: nil)
        currentAlertController = UIAlertController(title: "Please wait...",
                                                   message: "Reading tag memory",
                                                   preferredStyle: .alert)
        let okAction = UIAlertAction(title: "Stop", style: .default, handler: { _ in
            self.stopAction()
        })
        currentAlertController?.addAction(okAction)
        guard let aleart = currentAlertController else {
            return
        }
        present(aleart, animated: true, completion: nil)
    }
    private func stopAction() {
        appDelegate?.mReader?.stop()
    }
}
// MARK: - NSNotification
extension ReadMemoryViewController {
    @objc private func asReaderGUNDisconnected(_ notification: Notification?) {
        DispatchQueue.main.async {
            self.appDelegate?.mReader = nil
            self.navigationController?.popToRootViewController(animated: true)
        }
    }
}
// MARK: - Setters
extension ReadMemoryViewController {
    private func setBank(_ index: Int) {
        bankTextField.text = bankPickerData[index]
    }
    private func setOffset(_ index: Int) {
        offsetTextField.text = offsetPickerData[index]
        offsetValue = index
    }
    private func setLength(_ index: Int) {
        lengthTextField.text = lengthPickerData[index]
        lengthValue = index
    }
    private func setPassword(_ password: String?) {
        passwordTextField.text = password
    }
    private func setPowerGain(_ power: Int) {
        let value = String(format: "%i.0 dB", power)
        let index = powerGainPickerData.index(of: value) ?? 0
        if powerGainPickerData.count > index {
            powerGainTextField.text = powerGainPickerData[index]
        }
    }
    private func setOperationTime(_ operationTime: String?) {
        operationTimeTextField.text = operationTime
    }
    private func setReportRssiModeEnabled(_ enabled: Bool) {
        for elem in reportRssiCollection {
            elem.isEnabled = enabled
        }
        if !enabled {
            setReportRssiModeDefault()
        }
        reportRssiSwitch.isOn = enabled
    }
    private func setReportRssiModeDefault() {
        rssiLabel.text = String(format: "%.1f dB", 0.0)
        phaseLabel.text = String(format: "%.1f˚", 0.0)
    }
}
